﻿package monkeykong
{
    import flash.display.DisplayObject;
    import flash.display.Sprite;
    import flash.geom.Point;
    import monkeykong.gamestate.Gameplay;
    import monkeykong.gamestate.Title;
    import stego.core.BaseGame;
    import stego.debug.DebugWidget;
    import stego.util.music.Song;
    import stego.util.SceneLayers;
    import stego.widget.MusicCredits;

    public class MonkeyKong extends BaseGame
    {
        [Embed(source='../../assets/border.png')]
        protected static const FRAME_BITMAP_CLASS:Class;

        public override function Init(stageWidth:Number, stageHeight:Number):void
        {
            super.Init(stageWidth, stageHeight);

            Zoom = 2.0;

            ChangeGameState(new Title());

            Music.SongList = [ new Song( "http://www.meyermike.com/games/MonkeyKong/BestSong.mp3",
                                         "The Best Song In The World (Tribute)",
                                         "smiker",
                                         "http://8bitcollective.com/music/smiker/The+Best+Song+In+The+World+%28Tribute%29/",
                                         0.3),
                               new Song( "http://www.meyermike.com/games/MonkeyKong/bittribute.mp3",
                                         "Tenacious D - Tribute (8-bit Remix)",
                                         null,
                                         "http://www.youtube.com/watch?v=rerg0tmx9lI",
                                         1.0) ];
        }

        /**
         * add the persistent display objects that stick around even between levels
         */
        protected override function SetupScene():void
        {
            // holder for the game itself (gets moved to scroll the camera)
            mGameHolder = new Sprite();
            this.addChild(mGameHolder);

            _layers = new SceneLayers();
            Layers.Init(mGameHolder);

            CreatePauseIndicator();

            var frame:DisplayObject = new FRAME_BITMAP_CLASS();
            frame.scaleX = 2.0;
            frame.scaleY = 2.0;
            this.addChild(frame);

            _debugger = new DebugWidget();
            this.addChild(_debugger);

            // display for the music credits
            mMusicCredits = new MusicCredits(Music, StageWidth);
            mMusicCredits.Init();
            mMusicCredits.y = StageHeight - mMusicCredits.height;
            this.addChild(mMusicCredits);
        }
    }
}
