﻿package monkeykong.ingame
{
    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.geom.Matrix;
    import monkeykong.G;
    import stego.core.GameObject;

    public class Floor extends GameObject
    {
        [Embed(source='../../../assets/horiztile.png')]
        private static const GO_THROUGH_BMP_CLASS:Class;
        private static const GO_THROUGH_BMP:Bitmap = new GO_THROUGH_BMP_CLASS();
        private static const GO_THROUGH_BMP_DATA:BitmapData = GO_THROUGH_BMP.bitmapData;

        [Embed(source='../../../assets/verttile.png')]
        private static const SOLID_BMP_CLASS:Class;
        private static const SOLID_BMP:Bitmap = new SOLID_BMP_CLASS();
        private static const SOLID_BMP_DATA:BitmapData = SOLID_BMP.bitmapData;

        private var _canGoUpThrough:Boolean = true;
        public function get canGoUpThrough():Boolean { return _canGoUpThrough; }
        public function set canGoUpThrough(value:Boolean):void
        {
            _canGoUpThrough = value;
            Redraw(width, height);
        }

        private var _width:Number = G.TILE_SIZE;
        override public function get width():Number { return _width; }

        override public function set width(value:Number):void
        {
            _width = value;
            Redraw(value, height);
        }

        override public function Init():void
        {
            super.Init();
            AffectedByGravity = false;
            Redraw(G.TILE_SIZE, G.TILE_SIZE);
        }

        private function Redraw(width:Number, height:Number):void
        {
            graphics.clear();

            var bmpData:BitmapData = canGoUpThrough ? GO_THROUGH_BMP_DATA : SOLID_BMP_DATA;
            graphics.beginBitmapFill( bmpData, null, true);
            graphics.drawRect(
                0,
                0,
                width,
                height );
            graphics.endFill();
        }
    }

}
