﻿package monkeykong.titlescreen
{
    import stego.core.GameObject;
    import stego.Util;
    import stego.util.MathUtil;
    public class Brick extends GameObject
    {
        [Embed(source='../../../assets/brick.png')]
        private static const BRICK_GRAPHIC:Class;

        private static const LAUNCH_SPEED:Number = 200;

        public var hasBeenLaunched:Boolean;

        public override function Init():void
        {
            super.Init();
            rotation = 0;
            hasBeenLaunched = false;
            PhysicsEnabled = false;
            AffectedByGravity = false;
            CreateGraphics();
        }

        protected function CreateGraphics():void
        {
            if (0 == numChildren)
            {
                addChild(new BRICK_GRAPHIC());
            }
        }

        override public function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);
            if (!isOnScreen)
            {
                isAlive = false;
            }
        }

        public function Launch():void
        {
            dy = -LAUNCH_SPEED * Math.SQRT1_2;
            dx = Util.RandomBoolean() ? dy : -dy;
            rotation = 15 * MathUtil.Sign(dx);
            AffectedByGravity = true;
            hasBeenLaunched = true;
        }
    }
}
