﻿package stego.core
{
    import flash.events.Event;
    import flash.events.EventDispatcher;
    import stego.core.GameInterface;
    import stego.script.Step;
    import stego.script.step.Loop;
    import stego.script.step.Parallel;
    import stego.script.step.RunFunc;
    import stego.script.step.Wait;

    /**
     * ...
     * @author Mike Meyer
     */
    public class GameState extends EventDispatcher
    {
        private var _game:GameInterface;
        public function get Game():GameInterface { return _game; }

        protected var script:Step;

        /**
         * "heartbeat" function. called every frame
         */
        public function Update():void
        {
            if (null != script)
            {
                script.Execute(Game.Time.TimeDelta);
            }
        }

        /**
         * last-minute updating before things get rendered each frame
         */
        public function PreDraw():void
        {
        }

        /**
         * Go back to the beginning
         */
        public function Restart():void
        {
            End();
            Begin(Game);
            if (null != script)
            {
                script.Restart();
            }
        }

        /**
         * get the gamestate ready to be played
         */
        public function Begin(game:GameInterface):void
        {
            _game = game;

            if (null != script)
            {
                script.Restart();
            }
        }

        /**
         * clean up after the script
         */
        public function End():void
        {
            if (null != script)
            {
                script.Restart();
                script = null;
            }
        }
    }
}
