﻿package stego.debug
{
    import flash.events.Event;
    import flash.utils.getTimer;
    import stego.constants.Colors;
    import stego.core.GameObject;
    import stego.widget.TextField;
    /**
     * ...
     * @author Mike Meyer
     */
    public class FpsCounter extends GameObject
    {
        private var mTextField:TextField;
        private var mLastUpdated:int ;

        private static const mMovingAverageWindowSize:uint = 20;
        private var mFrameTimeValues:/*int */Array;
        private var mCurIndex:uint;

        public override function Init():void
        {
            super.Init();

            if (null == mTextField)
            {
                mTextField = new TextField();
                this.addChild(mTextField);
                mTextField.Init();
            }

            mFrameTimeValues = [];
            mCurIndex = 0;

            mTextField.SetFontColor(Colors.DESAT_GREEN);
            mTextField.SetText("-");
            mLastUpdated = getTimer();
        }

        public override function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);

            var currentTime:int = getTimer();
            mFrameTimeValues[mCurIndex] = currentTime-mLastUpdated;
            mCurIndex = (mCurIndex + 1) % mMovingAverageWindowSize;

            var total:int  = 0;
            for each (var value:int in mFrameTimeValues)
            {
                total += value;
            }
            var average:Number = (total / mFrameTimeValues.length);
            var frameRate:Number = 1000.0 / average;

            mTextField.SetText( String(frameRate.toFixed(2)) + " / " + stage.frameRate );
            mLastUpdated = currentTime;
        }
    }

}
