﻿package stego.script.step
{
    import flash.display.DisplayObject;
    import stego.script.Step;
    import stego.script.step.animate.AnimationValues;
    import stego.Util;

    /**
     *
     * @author Mike Meyer
     */
    public class Animate extends Step
    {
        protected var mTarget:DisplayObject;
        protected var mDuration:Number;
        protected var mCurTime:Number;

        protected var mStartValues:AnimationValues;
        protected var mEndValues:AnimationValues;

        public function Animate(objectToAnimate:DisplayObject, startValues:Object, endValues:Object, animDuration:Number=1.0)
        {
            mTarget = objectToAnimate;
            mStartValues = AnimationValues.BuildFromObject(startValues);
            mEndValues = AnimationValues.BuildFromObject(endValues);
            mDuration = animDuration;
            mCurTime = 0;
        }

        public override function Execute(timeDelta:Number):Boolean
        {
            mCurTime += timeDelta;

            AnimationValues.AnimateBetween(mTarget, mStartValues, mEndValues, mCurTime, mDuration);

            return (mCurTime >= mDuration);
        }

        /**
         * Go back to the beginning
         */
        public override function Restart():void
        {
            mCurTime = 0;
        }
    }

}
