﻿package stego.script.step
{
    import stego.script.Step;

    /**
     * Step to loop a bunch of other steps N times
     * @author Mike Meyer
     */
    public class LoopWhile extends Step
    {
        private var mCondition:Function;
        private var mSteps:/*Step*/Array;
        private var mNextStep:Number;

        public function LoopWhile(cond:Function, steps:Array)
        {
            mCondition = cond;
            mNextStep = 0;
            mSteps = steps.concat(); // make a copy
        }

        /**
         * Play the next step in the loop
         */
        public override function Execute(timeDelta:Number):Boolean
        {
            // early out if we're done
            if (true != mCondition())
            {
                return true;
            }

            // don't crash on empty steplists
            if (0 < mSteps.length)
            {
                var step:Step = mSteps[mNextStep];

                if (step.Execute())
                {
                    ++mNextStep;
                }

                if (mNextStep >= mSteps.length)
                {
                    mNextStep = 0;
                }
            }

            return false;
        }
    }

}
