﻿package stego.script.step
{
    import flash.events.Event;
    import flash.media.SoundChannel;
    import stego.script.Step;
    import flash.media.Sound;
    import stego.Sounds;

    /**
     * script step to start a sound and wait for it to finish
     */
    public class PlaySound extends Step
    {
        private var sound:Sound;
        private var channel:SoundChannel;
        private var soundComplete:Boolean;

        public function PlaySound(s:Sound)
        {
            sound = s;
            Restart();
        }

        /**
         * play the sound or continue waiting for it to finish
         * @return true if finished, false if it needs to be run some more
         */
        public override function Execute(timeDelta:Number):Boolean
        {
            if (null == channel)
            {
                channel = stego.Sounds.PlaySound(sound, null);
                channel.addEventListener(Event.SOUND_COMPLETE, SoundCompleted);
            }
            return soundComplete;
        }

        private function SoundCompleted(e:Event):void
        {
            channel.removeEventListener(Event.SOUND_COMPLETE, SoundCompleted);
            soundComplete = true;
        }

        /**
         * clear out any state information the step might be saving and
         * go back to like when it was first created
         */
        public override function Restart():void
        {
            if ( (null != channel) && (channel.hasEventListener(Event.SOUND_COMPLETE)) )
            {
                channel.removeEventListener(Event.SOUND_COMPLETE, SoundCompleted);
            }

            channel = null;
            soundComplete = false;
        }
    }
}
