﻿package stego.util
{
    /**
     * utility functions for working with Arrays
     * @author Mike Meyer
     */
    public class ArrayUtil
    {
        /**
         * remove items that are equal to the provided value
         */
        public static function RemoveEqual(a:Array, search:*, howMany:int=-1):void
        {
            RemovePredicate(a, function(x:*):Boolean { return (x == search); }, howMany );
        }

        /**
         * remove items for which the given predicate evaluates to true
         */
        public static function RemovePredicate(a:Array, predicate:Function, howMany:int=-1):void
        {
            for (var i:Number = 0 ; i < a.length; ++i)
            {
                if (predicate(a[i]))
                {
                    a.splice(i, 1);
                    if (howMany != -1)
                    {
                        --howMany;
                        if (howMany <= 0)
                        {
                            return;
                        }
                    }
                }
            }
        }
    }

}
